###################################################################################################
###################################################################################################
##                      Phalantium Wave v0.3 by BCS: TNG
##
##                      Made and maintained by USS Soverign
##
##  A script which requires NanoFX and QBautostart. What it does is damage everything in its
##  radius, friendly or enemy. Also the player's ship is damaged in the process. The mod works
##  via plugins so if you want this menu to show up you have to make a plugin. Via the plugin's
##  you also define how much damage will the wave do, don't worry you just pick the number and
##  the script does the rest for you.
##
##  Plugin Info: They're located in 'scripts\QBautostart\PhalWavePlugins' 
##
##  Credits: USS Sovereign for this script, Nanobyte for NanoFX 2 and Defiant for QBautostart
##
##  Requirements: NanoFX 2 Beta or higher and QBautostart 0.9.1 or higher
##
##  Permissions: Property of BCS: TNG do not modify or steal the code. Ask for permission!!!!!
###################################################################################################
###################################################################################################


# Imports
import App    
import MissionLib 
import Libs.LibEngineering
import Foundation
import Custom.NanoFXv2.NanoFX_Lib
import string

# Variables
pPlugin = None
pMenu = None
pCharge = None
pFire = None
pTimer1 = None

# Path to the GFX folder
GFX = 'scripts/Custom/QBautostart/PhalWaveData/'

# Load the baby in MP
MODINFO = {     "Author": "\"BCS:TNG\" <http://bcscripterstng.forumsplace.com/>",
                "Version": "0.3",
                "License": "GPL",
                "Description": "Phalantium Wave",
                "needBridge": 0
            }


# Start the listeners
def init():
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()

        # When you change a player ship then initiate the script
        App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".ShipCheck")
        
        

# We check to make sure that we're using the right ship over here
def ShipCheck(pObject, pEvent):
        global pPlugin, PhalStrength
        
        # Grab some values
        pPlayer = MissionLib.GetPlayer()

        # We don't want duplicate menus now, do we?!
        RemoveMenu()

        # Get the currently used ship HP
        pPlugin = None

        pPlugin = GetShipType(pPlayer)

        
        # Hmm... this ship has a plugin so load it and check if it's OK!
        try:

            # Import the module
            pModule = __import__("Custom.QBautostart.PhalWavePlugins." + pPlugin)

            # Check module properties
            if hasattr(pModule, "SHIP_HARDPOINT_NAME"):

                # All is ok, retrieve the value
                HPName = pModule.SHIP_HARDPOINT_NAME()

                # One final check before we add the menu
                if pPlugin == HPName:

                    # All is well build the menu
                    BuildMenu()

                    # Checking if the PhalWave strength is defined
                    if hasattr(pModule, "PHALATINUM_WAVE_STRENGTH"):

                        # PhalWave strength value is defined. Retrieving the value
                        PhalStrength = pModule.PHALATINUM_WAVE_STRENGTH()
                        
                        # Somebody messed up something, setting the Strength to 1
                        if PhalStrength <= 0:
                            PhalStrength = 1

                        # All is well use default values
                        elif PhalStrength == 1:
                            PhalStrength = 1
                        
                        elif PhalStrength == 2:
                            PhalStrength = 2

                        elif PhalStrength == 3:
                            PhalStrength = 3

                        elif PhalStrength == 4:
                            PhalStrength = 4

                        # Somebody's trying to cheat. Silly cheater!
                        elif PhalStrength >= 5:
                            PhalStrength = 5

                        # Some unknown error showed up so we're setting PhalStrength to 1
                        else:
                            PhalStrength = 1

                    # Phalantium Wave strength isn't defined then just do your stuff and set it to lowest value
                    else:
                        PhalStrength = 1
                        
                        print "PhalWave: Phalantium Wave strength isn't defined. No problem... Using default values"
                        

                # Give a console printout of an unsuccessfull Plugin Loading
                else:
                    print "PhalWave:", HPName, "plugin is invalid! Please consult the Readme for more info or contact BCS: TNG"        

            else:
                    # Also warn the user that something went wrong!
                    print "PhalWave:", HPName, "plugin is invalid! Please consult the Readme for more info or contact BCS: TNG" 

        # No plugins we won't do anything
        except:
            
            return
            

# Building a menu
def BuildMenu():
        global pMenu, pCharge, pFire

        # Make me a menu
        pBridge = App.g_kSetManager.GetSet('bridge')
	pScienceMenu = Libs.LibEngineering.GetBridgeMenu("Science")
	pMenu = App.STMenu_CreateW(App.TGString("Phalantium Wave"))
	pScienceMenu.PrependChild(pMenu)
    
        # Setup buttons
        pFire = Libs.LibEngineering.CreateMenuButton("Fire", "Science", __name__ + ".InitiateWaveSeq", 0, pMenu)
        pCharge = Libs.LibEngineering.CreateMenuButton("Charge", "Science", __name__ + ".ChargingSequence", 0, pMenu)

        # Disable some options
        pCharge.SetEnabled()
        pFire.SetDisabled()


# Charging sequence and setting some event handlers
def ChargingSequence(pObject, pEvent):
        global pTimer1, PhalStrength, pCharge

        # Phal Strength is needed over here
        PhalStrength2 = PhalStrength

        # Grab the menu buttons to setup event handlers
        pSaffiQB = GetMenuButton("Commander", "End Combat")
        pSaffiQBR = GetMenuButton("Commander", "Configure")

        # Grab a lot of values for this def
        pPlayer = MissionLib.GetPlayer()
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()
        pPhasers = pPlayer.GetPhaserSystem()
    	pPulse = pPlayer.GetPulseWeaponSystem()
    	pTorps = pPlayer.GetTorpedoSystem()
    	pHull = pPlayer.GetHull()
        pHullCon = pHull.GetCondition() 
        pHullMax = pHull.GetMaxCondition() / 1.5

        # Phalantium wave is integrated in the ship's hull and if it's damaged you cannot use Phalantium Wave
        if pHullMax > pHullCon:
            Sound = App.TGSound_Create("sfx/Custom/PhalWave/FunctionsOffline.mp3", "FunctionsOffline", 0)
            Sound.SetSFX(0)
            Sound.SetInterface(1)
            App.g_kSoundManager.PlaySound("FunctionsOffline")
            return
        

        # Setting up event handlers
        if pSaffiQB:
                pSaffiQB.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".PhalWaveReset")


        if pSaffiQBR:
                pSaffiQBR.AddPythonFuncHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".PhalWaveReset")

        App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_SET_PLAYER, pMission, __name__ + ".PhalWaveReset")
        App.g_kEventManager.AddBroadcastPythonFuncHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")


        # Checking the PhalStrength and setting up a proper timer based value
        if PhalStrength2 == 1:
            DelayValue = 25

        elif PhalStrength2 == 2:
            DelayValue = 45

        elif PhalStrength2 == 3:
            DelayValue = 75

        elif PhalStrength2 == 4:
            DelayValue = 100

        elif PhalStrength2 == 5:
            DelayValue = 120

        # Disabling weapons to make things fair, balancing issue. We need all the power we can get from weapons
        if pPhasers:
            pPhasers.GetProperty().SetDisabledPercentage(100.0)

        if pPulse:
            pPulse.GetProperty().SetDisabledPercentage(100.0)

        if pTorps:
            pTorps.GetProperty().SetDisabledPercentage(100.0)


        # Inform user that he can use Phalantium Wave and that it is charging
        Sound2 = App.TGSound_Create("sfx/Custom/PhalWave/CodesVerified.mp3", "CodesVerified", 0)
        Sound2.SetSFX(0)
        Sound2.SetInterface(1)
        App.g_kSoundManager.PlaySound("CodesVerified")

        # Possible bugfix, disabling transport button
        DisableTransport()

        # Disable charge button
        pCharge.SetDisabled()

        # Initiate timer based event to enable the button to fire
        pTimer1 = MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EnableFiring", App.g_kUtopiaModule.GetGameTime() + DelayValue, 0, 0)


# Reset function, all BCS: TNG scripts have one
def PhalWaveReset(pObject, pEvent):
        global pFire, pCharge

        # Reset buttons
        pCharge.SetEnabled()
        pFire.SetDisabled()

        # Reenabling transport button
        ReenableTransport()

        # Deleting timer
        DeleteTimer(None, None)

        # Grabing some values that we need for our event handlers
        pGame = App.Game_GetCurrentGame()
        pEpisode = pGame.GetCurrentEpisode()
        pMission = pEpisode.GetCurrentMission()

        # Grabbing buttons
        pSaffiQB = GetMenuButton("Commander", "End Combat")
        pSaffiQBR = GetMenuButton("Commander", "Configure")

        # Removing event handler
        if pSaffiQB:
                pSaffiQB.RemoveHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".PhalWaveReset")

        if pSaffiQBR:
                pSaffiQBR.RemoveHandlerForInstance(App.ET_ST_BUTTON_CLICKED, __name__ + ".PhalWaveReset")
            
        App.g_kEventManager.RemoveBroadcastHandler(App.ET_OBJECT_EXPLODING, pMission, __name__ + ".ShipExploding")
        App.g_kEventManager.RemoveBroadcastHandler(App.ET_SET_PLAYER, pMission, __name__ + ".PhalWaveReset")


# You may fire now sir
def EnableFiring(pObject, pEvent):
        global pFire, pCharge

        # Firing is enabled, grab some values
        pPlayer = MissionLib.GetPlayer()
        pPhasers = pPlayer.GetPhaserSystem()
    	pPulse = pPlayer.GetPulseWeaponSystem()
    	pTorps = pPlayer.GetTorpedoSystem()

        # Weapons are back online
    	if pPhasers:
            pPhasers.GetProperty().SetDisabledPercentage(0.0)

        if pPulse:
            pPulse.GetProperty().SetDisabledPercentage(0.0)

        if pTorps:
            pTorps.GetProperty().SetDisabledPercentage(0.0)

        
        # Inform the user via SFX that he may now fire
        Sound = App.TGSound_Create("sfx/Custom/PhalWave/LockedOn.mp3", "LockedOn", 0)
	Sound.SetSFX(0)
	Sound.SetInterface(1)
	App.g_kSoundManager.PlaySound("LockedOn")

        # Buttons set to their appropriate values
        pFire.SetEnabled()
        pCharge.SetDisabled()

        # Transport button is enabled again now
        ReenableTransport()


# Deleting the button reenabling timer
def DeleteTimer(pObject, pEvent):
        global pTimer1
        
        try:
                    App.g_kTimerManager.DeleteTimer(pTimer1.GetObjID())
                    App.g_kRealtimeTimerManager.DeleteTimer(pTimer1.GetObjID())
                    pTimer1 = None
        except:
                    pass


# Initiate Wave Sequence
def InitiateWaveSeq(pObject, pEvent):
         global pFire, pCharge
         # Create a pretty cutscene and turn on NanoFX flickering
         pPlayer = MissionLib.GetPlayer()
         pSequence = App.TGSequence_Create ()
         pSequence.AppendAction (App.TGScriptAction_Create("MissionLib", "StartCutscene"))
         pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "StartCinematicMode", 0))
         pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraBegin", pPlayer.GetContainingSet().GetName ()))
         pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "LockedView", pPlayer.GetContainingSet().GetName(), pPlayer.GetName(), 350, 10, 25))
         pSequence.AddAction(Custom.NanoFXv2.NanoFX_Lib.CreateFlickerSeq(pPlayer, 1.5, sStatus = "Off"), App.TGAction_CreateNull(), 1.0)
         pSequence.Play()

         # Go to the next function
         MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".InitiateWaveSeq2", App.g_kUtopiaModule.GetGameTime() + 5, 0, 0)

         # Disable/Enable the button
         pFire.SetDisabled()
         pCharge.SetEnabled()

# Wave seq part 2
def InitiateWaveSeq2(pObject, pEvent):
         SetPlayerImpulse(None, None)
         pSequence = App.TGSequence_Create ()
         # Initiate the GFX sequence
         pSequence.AppendAction(StartSeq(), 1.0)

         MissionLib.CreateTimer(Libs.LibEngineering.GetEngineeringNextEventType(), __name__ + ".EndSeq", App.g_kUtopiaModule.GetGameTime() + 5, 0, 0)

# Ending Sequence
def EndSeq(pObject, pEvent):
        # End the cutscene and turn on ship lights
        pPlayer = MissionLib.GetPlayer()
        pSequence = App.TGSequence_Create ()
        pSequence.AddAction(Custom.NanoFXv2.NanoFX_Lib.CreateFlickerSeq(pPlayer, 1.5, sStatus = "On"), App.TGAction_CreateNull(), 1.0)
        pSequence.AppendAction(App.TGScriptAction_Create("Actions.CameraScriptActions", "CutsceneCameraEnd", pPlayer.GetContainingSet().GetName ()))
        # Switch to bridge view
        if App.g_kSetManager.GetSet("bridge"):
                 pAction = App.TGScriptAction_Create("Actions.CameraScriptActions", "ChangeRenderedSet", "bridge")
                 pSequence.AppendAction(pAction)
        pSequence.AppendAction(App.TGScriptAction_Create("MissionLib", "EndCutscene"))
        pSequence.Play()

# Initiating GFX and all other sequences
def StartSeq():
        Initiate()
        PlayWaveSound(None, None)
        DamagePlayer(None, None) 
        InitiateWave(None, None)
        

# Setting Impulse power to 0
def SetPlayerImpulse(pObject, pEvent):
                pPlayer = MissionLib.GetPlayer()
                pPlayer.SetSpeed(0, App.TGPoint3_GetModelForward(), App.PhysicsObjectClass.DIRECTION_MODEL_SPACE)

                return

# Initiate Wave 
def InitiateWave(pObject, pEvent):
        global PhalStrength

        # Phal Strength is used over here also to define damage that is done to other ships
        PhalStrength2 = PhalStrength

        # Grabbing some values
        pPlayer = MissionLib.GetPlayer()
        PlayerName = pPlayer.GetName()
        pSet = pPlayer.GetContainingSet()

        # Selecting which damage settings to use
        if PhalStrength2 == 1:
                Dam1 = 0.15
                Dam2 = 0.20
                Dam3 = 0.05
                Dam4 = 0.10
                Dam5 = 0.01
                Dam6 = 0.04
                

        elif PhalStrength2 == 2:
                Dam1 = 0.25
                Dam2 = 0.30
                Dam3 = 0.15
                Dam4 = 0.20
                Dam5 = 0.05
                Dam6 = 0.10

    
        elif PhalStrength2 == 3:
                Dam1 = 0.45
                Dam2 = 0.50
                Dam3 = 0.35
                Dam4 = 0.40
                Dam5 = 0.15
                Dam6 = 0.20
                

        elif PhalStrength2 == 4:
                Dam1 = 0.65
                Dam2 = 0.70
                Dam3 = 0.55
                Dam4 = 0.60
                Dam5 = 0.40
                Dam6 = 0.45
                

	elif PhalStrength2 == 5:
                Dam1 = 0.90
                Dam2 = 0.95
                Dam3 = 0.80
                Dam4 = 0.85
                Dam5 = 0.70
                Dam6 = 0.75

                
        # Loop through all ships in the set and damage all that are in range
        for kShip in pSet.GetClassObjectList(App.CT_SHIP):
                pShip = App.ShipClass_GetObject(pSet, kShip.GetName())
                pShip2 = App.ShipClass_Cast(pShip)
                # Player ship, don't damage it
                if (kShip.GetName() == PlayerName):
                    continue
                # Ship is less in 20 Km range 
                if DistanceCheck(pShip) < 120:
                    DamageShip(pShip, fMinPercent = Dam1, fMaxPercent = Dam2)
                    AddDamage(pShip2)
                # Ship is in med range, do a med damage 
                elif DistanceCheck(pShip) < 180:
                    DamageShip(pShip, fMinPercent = Dam3, fMaxPercent = Dam4)
                    AddDamage(pShip2)
                # Ship is far, far away do low damage
                elif DistanceCheck(pShip) < 240:
                    DamageShip(pShip, fMinPercent = Dam5, fMaxPercent = Dam6)
                    AddDamage(pShip2)
                # Not in range, just go ahead don't do anything
                else:
                    continue

# Play the wave sound
def PlayWaveSound(pObject, pEvent):
        Sound = App.TGSound_Create("sfx/Custom/PhalWave/WaveSFX.mp3", "WaveSFX", 0)
	Sound.SetSFX(0)
	Sound.SetInterface(1)
	App.g_kSoundManager.PlaySound("WaveSFX")
	

# Damage player's hull and warp core as a backfire effect
def DamagePlayer(pObject, pEvent):
        global PhalStrength
        
        # We also need Phal Strenght to determine backfire player effect
        PhalStrength2 = PhalStrength

        if PhalStrength2 == 1:
            DivideValue = 50

        elif PhalStrength2 == 2:
            DivideValue = 40

        elif PhalStrength2 == 3:
            DivideValue = 25

        elif PhalStrength2 == 4:
            DivideValue = 10

        elif PhalStrength2 == 5:
            DivideValue = 5

        else:
            DivideValue = 1.5
            print "PhalWave: An unknown error has occured, Phalantium Wave will function... BUT not properly. Please consult BCS: TNG!"

        # Grabbing some values
        pPlayer = MissionLib.GetPlayer()
        pShields = pPlayer.GetShields()
        pShieldMax = pShields.GetMaxCondition() / DivideValue
        pShieldCon = pShields.GetCondition()
        pHull = pPlayer.GetHull()
        pHullMax = pHull.GetMaxCondition() / DivideValue
        pHullCon = pHull.GetCondition()

        # Setting system conditions
        pShields.SetCondition(pShieldCon - pShieldMax)
        pHull.SetCondition(pHullCon - pHullMax)

# Just a simple distance check
def DistanceCheck(pObject):
	pPlayer = App.Game_GetCurrentGame().GetPlayer()
	vDifference = pObject.GetWorldLocation()
	vDifference.Subtract(pPlayer.GetWorldLocation())

	return vDifference.Length()    


# Damage a ship
def DamageShip(pShip, fMinPercent = 0.25, fMaxPercent = 0.75):

	
        Hull = pShip.GetHull()
        if Hull:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Hull, r)
            

        Shields = pShip.GetShields()
        if Shields:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Shields, r)

        Power = pShip.GetPowerSubsystem()
        if Power:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Power, r)


        Sensor = pShip.GetSensorSubsystem()
        if Sensor:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Sensor, r)


        Torp = pShip.GetTorpedoSystem()
        if Torp:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Torp, r)

        Phaser = pShip.GetPhaserSystem()
        if Phaser:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Phaser, r)

        Pulse = pShip.GetPulseWeaponSystem()
        if Pulse:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Pulse, r)

        Tractor = pShip.GetTractorBeamSystem()
        if Tractor:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Tractor, r)



        Impulse = pShip.GetImpulseEngineSubsystem()
        if Impulse:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Impulse, r)

        Warp = pShip.GetWarpEngineSubsystem()	
        if Warp:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Warp, r)

        Repair = pShip.GetRepairSubsystem()	
        if Repair:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Repair, r)

        Cloak = pShip.GetCloakingSubsystem()
        if Cloak:
                        r = GetRandomDamage(fMinPercent, fMaxPercent)

	
			SetConditionPercentage(pShip, Cloak, r)

		

# Select from 2 damage types
def GetRandomDamage(fMinPercent, fMaxPercent):
    
	Selection = App.g_kSystemWrapper.GetRandomNumber(5) + 5

        if Selection > 5:
             r = fMaxPercent
             
             return r

        else:
             r = fMinPercent
             
             return r
	

# Set a random condition percentage
def SetConditionPercentage(pShip, pSubsystem, fPercent, bIsChild = 0):
	if (bIsChild != 0) or (pSubsystem.GetNumChildSubsystems() == 0):
                Stats = pSubsystem.GetConditionPercentage()
                Calculation = Stats - fPercent
                if (Calculation <= 0.01):
                    pShip.DestroySystem(pSubsystem)

                else:
                    pSubsystem.SetConditionPercentage(Stats - fPercent)

	for i in range(pSubsystem.GetNumChildSubsystems()):
		pChild = pSubsystem.GetChildSubsystem(i)

		if (pChild != None):
			SetConditionPercentage(pShip, pChild, fPercent, 1)

# Load the GFX
def StartGFX():
                LoadGfx(8,2,GFX)

# Create these textures on the ship
def CreateGFX():
                # First basic stuff we define where where from we'll emmit those textures etc.
                pPlayer = MissionLib.GetPlayer()
		pAttachTo = pPlayer.GetNode()
		fSize     = 25
		pSequence = App.TGSequence_Create()	
		pEmitFrom = App.TGModelUtils_CastNodeToAVObject(pPlayer.GetNode())

                # Setup some needed values	
                sFile = ChooseRandomTexture()
                iTiming = 15.0
                fLifeTime = 1
                fRed = 255.0
                fGreen = 255.0
                fBlue = 255.0
                fBrightness = 0.8
                fSpeed = iTiming / 15.0

                # We start creating the effect, also very similar to the code from effects.py                
		pEffect = App.AnimTSParticleController_Create()
		pEffect.AddColorKey(0.0, fRed / 255, fGreen / 255, fBlue / 255)
		pEffect.AddColorKey(1.0, fRed / 255, fGreen / 255, fBlue / 255)
		pEffect.AddAlphaKey(0.0, 1.0)
		pEffect.AddAlphaKey(1.0, 1.0)
		pEffect.AddSizeKey(0.0, fSize)
		pEffect.AddSizeKey(1.0, fSize)
		
                pEffect.SetEmitLife(fSpeed)
                pEffect.SetEmitFrequency(1)
                pEffect.SetEffectLifeTime(fSpeed + fLifeTime)
                pEffect.SetInheritsVelocity(0)
                pEffect.SetDetachEmitObject(0)
                pEffect.CreateTarget(sFile)
                pEffect.SetTargetAlphaBlendModes(0, 7)
                pEffect.SetEmitFromObject(pEmitFrom)
                pEffect.AttachEffect(pAttachTo)                
                Effect = App.EffectAction_Create(pEffect)
                pSequence.AddAction(Effect)
                pSequence.Play ()
                
                return

# Support for multiple textures, thanks LJ ;)
def ChooseRandomTexture():
                iRandom = App.g_kSystemWrapper.GetRandomNumber(len(Foundation.GetFileNames(GFX, 'tga')))
                strFile = GFX + "Wave" + str(iRandom) + ".tga"
                
                return strFile

# Load textures
def LoadGfx(iNumXFrames, iNumYFrames, Folder):
                FileNames = Foundation.GetFileNames(Folder, 'tga')       

                for loadIndex in FileNames:
                        strFile = Folder + str(loadIndex)
                        fX = 0.0
                        fY = 0.0

                        pContainer = App.g_kTextureAnimManager.AddContainer(strFile)   
                        pTrack = pContainer.AddTextureTrack(iNumXFrames * iNumYFrames)
                        for index in range(iNumXFrames * iNumYFrames):
                                pTrack.SetFrame(index, fX, fY + (1.0 / iNumYFrames), fX + (1.0 / iNumXFrames), fY)
                                fX = fX + (1.0 / iNumXFrames)

                                if (fX == 1.0):
                                        fX = 0.0
                                        fY = fY + (1.0 / iNumYFrames)

                
# We call this upper in the script and it calls all relevant data to create a texture
def Initiate():
                StartGFX()
                for i in range(1):
                    CreateGFX()

# It returns currently used Ship HP, needed for plugin checking
def GetShipType(pShip):
                if pShip.GetScript():
                        return string.split(pShip.GetScript(), '.')[-1]
                return None

# A handler which detects if the player's ship is exploding or some other ship...
def ShipExploding(pObject, pEvent):
                pPlayer = App.Game_GetCurrentGame().GetPlayer()

                # Get the ship that is exploding.
                pShip = App.ShipClass_Cast(pEvent.GetDestination())
                if (pShip != None):
                        iShipID = pShip.GetObjID()
                        if pPlayer and pShip.GetName() == pPlayer.GetName():
                                # It's us.  Reset.
                                PhalWaveReset(None, None)


# Removes a menu, just in case you don't have Phal Wave equipped ship or worse... We can Have duplicate menus, well you'll see if you disable this line
def RemoveMenu():
        g_pDatabase = App.g_kLocalizationManager.Load("data/TGL/PhalatinumWave.tgl")
        pBridge = App.g_kSetManager.GetSet("bridge")
        g_pPerson = App.CharacterClass_GetObject(pBridge, "Science")
        pMenu = g_pPerson.GetMenu()
	if (pMenu != None):
		pButton = pMenu.GetSubmenu("Phalantium Wave")
		if (pButton != None):
			pMenu.DeleteChild(pButton)

# Get menu button
def GetMenuButton(sMenuName, sButtonName):
        pMenu = GetBridgeMenu(sMenuName)
        if not pMenu:
                return

        # Grab the starting button.    
        pButton = pMenu.GetButton(sButtonName)
        if not pButton:
                pButton = pMenu.GetSubmenu(sButtonName)
                if not pButton: 
                        return
        return pButton


# Get any menu
def GetBridgeMenu(menuName):
	pTactCtrlWindow = App.TacticalControlWindow_GetTacticalControlWindow()
	pDatabase = App.g_kLocalizationManager.Load("data/TGL/Bridge Menus.tgl")
	if(pDatabase is None):
		return
	return pTactCtrlWindow.FindMenu(pDatabase.GetString(menuName))


# Originally developed in an unreleased script Self-Manhiem
def DisableTransport():
                pEngTransport = GetMenuButton("Engineer", "Transporter")

                if pEngTransport:
                    pEngTransport.SetDisabled()


# Opposite of disable transport def 
def ReenableTransport():
                pEngTransport = GetMenuButton("Engineer", "Transporter")

                if pEngTransport:
                    pEngTransport.SetEnabled()

# From Transport Torps some random coordinates which add visable damage to ships
def AddDamage(pThingToDamage):
	pThingToDamage.AddObjectDamageVolume(-0.346769, 0.505777, 0.211104, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.391424, 0.292077, 0.136891, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.480019, 0.478436, 0.055110, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.491906, -0.009849, 0.036503, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.410636, -0.320572, 0.163709, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.033209, -0.662447, 0.254643, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.088509, -1.154540, 0.234934, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.273566, -1.192976, 0.216826, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.311354, -0.558230, 0.230304, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.222401, 0.425513, 0.261027, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.059797, 0.854007, 0.315946, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.056210, 1.548879, 0.118923, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.010570, 1.840008, -0.062665, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.004918, 1.929916, -0.118732, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.001939, 1.938382, -0.123910, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.255125, 1.524279, -0.107981, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.340457, 0.871074, 0.058321, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.000847, 1.163047, 0.295946, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.447814, 0.288307, 0.028379, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.234699, 0.027302, 0.259706, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.335636, -1.328933, 0.166836, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.347983, -0.744068, 0.144445, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.532026, 0.467509, -0.147177, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.482553, -0.298320, -0.226326, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.351669, -0.343077, -0.383422, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.278125, 0.289238, -0.398746, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.178232, 1.112100, -0.162443, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.134755, 0.889398, -0.217919, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.205823, 0.698926, -0.398746, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.296626, 1.243148, -0.134832, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.126445, 1.415870, -0.158072, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.067971, -0.037120, -0.398747, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.149664, 0.196479, -0.398746, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.121442, -0.420599, -0.398748, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.147468, -0.721491, -0.003603, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.034781, -0.636699, -0.041525, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.103933, -1.060943, -0.001106, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.072679, -1.187713, -0.001000, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.037587, -1.391599, -0.000836, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.128441, 0.075653, -0.398749, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.128440, 0.075653, -0.398747, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.071726, 0.209187, -0.398747, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.345813, -0.685381, -0.614542, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.302524, -0.706135, -0.631574, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.146801, -0.782789, -0.676372, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.455602, -0.667914, -0.574382, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.572804, -0.813001, -0.547154, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.193804, -0.733335, -0.662817, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.214107, -0.574814, -0.642235, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.611432, -0.572691, -0.529461, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.070807, -0.379312, -0.635533, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.030613, -0.145652, -0.346971, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.005559, -0.121254, -0.283762, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.034129, -0.964541, 0.066513, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.036802, -1.037225, 0.000659, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.507236, -0.634171, 0.328817, 0.400000, 300.000000)
        pThingToDamage.AddObjectDamageVolume(0.929057, -0.201515, 0.400643, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.801802, -0.304561, 0.388759, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.666115, -0.397717, 0.373515, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.213361, -0.245429, 0.359157, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.851782, -0.351260, 0.371372, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.809756, 0.016150, 0.454896, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.587137, 0.397876, 0.526805, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.541201, 0.492356, 0.540685, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.375059, 0.726711, 0.576656, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.046282, 3.098201, 0.357073, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.042288, 2.960103, 0.394244, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.345629, 2.530174, 0.479749, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.685705, 1.910513, 0.545903, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.490639, 2.268348, 0.517067, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.136996, 2.856081, 0.419813, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.636938, 1.985357, 0.541501, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.804660, 1.689765, 0.553807, 0.400000, 300.000000)
        pThingToDamage.AddObjectDamageVolume(-1.137933, 1.015570, 0.528061, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.279356, 0.771891, 0.498532, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.346444, 0.670076, 0.481998, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.428968, 0.523097, 0.458471, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.649349, 0.111432, 0.362016, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.500440, 0.353440, 0.428241, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.018135, 1.258580, 0.545868, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.778010, 0.915723, 0.282265, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.753688, 1.235525, 0.282169, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.699858, 1.313243, 0.282100, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.376720, 1.519782, 0.215094, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.442958, 1.516261, 0.229245, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(2.141679, 1.319118, 0.282607, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.940048, 1.834173, 0.162829, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.694127, 1.926775, 0.143619, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.669067, 2.031247, 0.158117, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.787049, -2.450481, -0.479406, 0.400000, 300.000000)
        pThingToDamage.AddObjectDamageVolume(0.472988, -2.582106, -0.479406, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.332775, -2.606269, -0.479406, 0.400000, 300.000000)
        pThingToDamage.AddObjectDamageVolume(1.491975, -2.752262, -0.185564, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.492164, -2.546745, -0.185347, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.519967, -2.418399, -0.174117, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.537456, -2.011956, -0.106467, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.493736, -1.214339, -0.124618, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.293176, -0.893505, 0.057163, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.465843, -1.078616, 0.047023, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.517567, -1.529963, 0.029249, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.506633, -1.556521, 0.051007, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.383068, -1.955101, -0.400695, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.405347, -1.597944, -0.332310, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.434705, -1.311026, -0.304137, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.491449, -2.187363, -0.479408, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(1.871296, 1.205940, 0.423314, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.622082, 1.532477, 0.096169, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-0.887656, 1.790044, 0.149888, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.070588, 2.159536, 0.236573, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.110948, 2.139911, 0.240968, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.290856, 2.453246, 0.282340, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(0.151287, -2.431957, -0.520467, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.152492, -2.776111, -0.496844, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.225880, -2.674515, -0.449059, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.392438, -3.107039, -0.173366, 0.400000, 300.000000)
	pThingToDamage.AddObjectDamageVolume(-1.426545, -3.150084, -0.167093, 0.400000, 300.000000)
